﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;

public class SimplePlayerController : MonoBehaviour {
	public GameObject[] beaconList;
	public GameObject player;
	public float speed;
	public Coroutine moveCoroutine;
	public String playerPos;
	String desiredPos = "-1";
	GameObject closeNeighbor;
	//public Vector3 transform.position;

	// Use this for initialization
	void Start () {
		if (speed == null) {
			speed = 5.0f;
		}
		beaconList = GameObject.FindGameObjectsWithTag("boyas");
		playerPos = "C2";
		for (int i = 0; i < beaconList.Length; i++) {
			String beaconName = beaconList[i].name;
			if (beaconName == playerPos) {
				player.transform.position = beaconList[i].transform.position;
				//  transform.position = Vector3.MoveTowards(player.transform.position, beaconList[i].transform.position,  
				//  speed * Time.deltaTime);
			}
		}
	}
	
	// Update is called once per frame
	void Update () {
		float movV = Input.GetAxis("Vertical");
		float movH = Input.GetAxis("Horizontal");
		if (desiredPos == "-1" || desiredPos == playerPos) {
			if (movV != 0 || movH != 0) {
				if (moveCoroutine != null) StopCoroutine(moveCoroutine);
				moveCoroutine = StartCoroutine(RutinaMover(movV, movH));
			}
		} else if (closeNeighbor != null) {
		/*	GameObject closeNeighbor = null;
					for (int i = 0; i < beaconList.Length; i++) {
				String beaconName = beaconList[i].name;
				if (beaconName == desiredPos) {
					closeNeighbor= beaconList[i];
					// playerPos = beaconList[i].name;
					break;
				}
			}*/
			 transform.position = Vector3.MoveTowards(player.transform.position, 
			 closeNeighbor.transform.position,  speed * Time.deltaTime);
			 if (Mathf.Abs((transform.position - closeNeighbor.transform.position).magnitude) <= 0.1f) {
				// transform.position = Vector3.MoveTowards(transform.position, closeNeighbor.transform.position,  
				//  speed * Time.deltaTime);
				playerPos = closeNeighbor.name;
			} 

		}
		//  float step = speed * Time.deltaTime;
        	// transform.position = Vector3.MoveTowards(transform.position, beaconList[0].transform.position, step);

	}

	IEnumerator RutinaMover (float movV, float movH) {
		// Debug.Log("jajajaj");
		String playerColumn = playerPos.Substring(0, 1);
		String playerRow = playerPos.Substring(1, 1);
		
		Debug.Log(desiredPos + "*-" + playerPos );
		

			for (int i = 0; i < beaconList.Length; i++) {
				String beaconName = beaconList[i].name;
				if (movV > 0) {
					if (playerColumn == "C") {
						if (beaconName == "B" + playerRow) {
							closeNeighbor= beaconList[i];
							// playerPos = beaconList[i].name;
							break;
						}
					} else if (playerColumn == "B") {
						if (beaconName == "A" + playerRow) {
							closeNeighbor= beaconList[i];
							// playerPos = beaconList[i].name;
							break;
						}
					}

				} else if (movV < 0) {
					if (playerColumn == "A") {
						if (beaconName == "B" + playerRow) {
							closeNeighbor= beaconList[i];
							// playerPos = beaconList[i].name;
							break;
						}
					} else if (playerColumn == "B") {
						if (beaconName == "C" + playerRow) {
							closeNeighbor= beaconList[i];
							// playerPos = beaconList[i].name;
							break;					}
					}

				} else if (movH > 0) {
					if (playerRow == "1") {
						if (beaconName == playerColumn + "2") {
							closeNeighbor= beaconList[i];
							// playerPos = beaconList[i].name;
							break;
						}
					} else if (playerRow == "2") {
						if (beaconName == playerColumn + "3") {
							closeNeighbor= beaconList[i];
							// playerPos = beaconList[i].name;
							break;
						}
					}

				} else if (movH < 0) {
					if (playerRow == "2") {
						if (beaconName == playerColumn + "1") {
							closeNeighbor= beaconList[i];
							// playerPos = beaconList[i].name;
							break;
						}
					} else if (playerRow == "3") {
						if (beaconName == playerColumn + "2") {
							closeNeighbor= beaconList[i];
							// playerPos = beaconList[i].name;
							break;
						}
					}

				}
			}
		//} else {
			// for (int i = 0; i < beaconList.Length; i++) {
			// 	String beaconName = beaconList[i].name;
			// 	if (beaconName == desiredPos) {
			// 		closeNeighbor= beaconList[i];
			// 		// playerPos = beaconList[i].name;
			// 		break;
			// 	}
			// }
		//}
		if (closeNeighbor != null) {
			 transform.position = Vector3.MoveTowards(player.transform.position, 
			 closeNeighbor.transform.position,  speed * Time.deltaTime);
			 desiredPos =  closeNeighbor.name;
			 //Debug.Log(transform.position);
			if (Mathf.Abs((transform.position - closeNeighbor.transform.position).magnitude) > 0.1f) {
				// transform.position = Vector3.MoveTowards(transform.position, closeNeighbor.transform.position,  
				//  speed * Time.deltaTime);
				Debug.DrawLine(transform.position, closeNeighbor.transform.position, 
				Color.yellow);
			} else {

				playerPos = closeNeighbor.name;

			}
			Debug.Log("hacia " +  closeNeighbor.name + " desde " + playerPos);
			yield return new WaitForSeconds(10);


		} else {
			// Debug.Log("me voy");
			
			yield return new WaitForSeconds(1);
		}

	}
}
